package com.jeeplus.test.cw.contractRegistration.domain;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jeeplus.core.domain.BaseEntity;
import com.jeeplus.core.query.Query;
import com.jeeplus.core.query.QueryType;
import com.jeeplus.test.cw.workClientInfo.service.dto.CwWorkClientBaseDTO;
import com.jeeplus.test.workContract.service.dto.WorkAttachmentDto;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * @author: 王强
 * @create: 2022-11-08 10:42
 **/
@Data
@TableName(value = "cw_work_contract_info")
public class ContractInfo extends BaseEntity {

    //合同编号（字典值）
    public static final String BIZ_CODE = "10";

    @Query(tableColumn = "a.contract_no")
    private String contractNo;              //合同编号
    @Query(tableColumn = "a.contract_name")
    private String contractName;            //合同名称

    private String payerSubject;            //付款主体
    private String paymentMethod;           //付款方式
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date signingDate;             //签约日期
    @Query(tableColumn = "a.contract_amount")
    private Double contractAmount;          //合同金额（元）
    private Double actualContractAmount;    //合同实际金额
    private String contractNum;             //合同份数
    private String paymentAgreement;        //付款约定
    @TableField(fill = FieldFill.UPDATE)
    private String changeNum;               //修改次数
//    @Query(tableColumn = "a.department")
    private String department;              //所属部门
    private String clientContacts;          //委托方联系人
    private String clientContactsPhone;     //委托方联系人电话
    private String contractApprovalType;    //合同归档审批类型
    private String procInsId;               //流程id
    private String processDefinitionId;     //
    private String status;                  //状态

    @TableField(fill = FieldFill.INSERT)
    private String createBy;                //创建人名称

    @TableField(exist = false)
    @Query(tableColumn = "c.id",type = QueryType.EQ)
    private String createId;                //创建人id

    @TableField(exist = false)
    private String contractStatus;          //合同状态

    @TableField(exist = false)
    private String taskFiledId;

    @TableField(exist = false)
    private String taskFiledProcInsId;

    @TableField(exist = false)
    private String taskFiledPaperProcInsId;

    /**
     * 归档状态
     */
    @Query(tableColumn = "a.filed_type")
    private String filedType;

    /**
     * 纸质归档状态
     */
    private String filedPaperType;

    @TableField(exist = false)
    private String[] contractAmounts;

    @TableField(exist = false)
    private String[] contractDates;

    /**
     * 附件信息
     */
    @TableField(exist = false)
    private List<WorkAttachmentDto> contractProperList;

    /**
     * 被服务单位信息
     */
    @TableField(exist = false)
    private List<CwWorkClientBaseDTO> cwWorkClientContactDTOList;

    @TableField(exist = false)
    private String departmentName;

    /**
     * 归档附件信息
     */
    @TableField(exist = false)
    private List<WorkAttachmentDto> contractInfoList;

    /**
     * 合同金额类别
     */
    private String contractAmountType;

    /**
     * 对方合同编号
     */
    private String contractOpposite;

    /**
     * 收费标准
     */
    private String contractFee;

    private String fees;

    /**
     * 案卷号
     */
    @TableField(exist = false)
    private String filedNo;
    /**
     * 确认案卷号
     */
    @TableField(exist = false)
    private String confirmFiledNo;

    /**
     * 借用状态
     */
    private String borrowType;

    @TableField(exist = false)
    private String taskBorrowId;

    /**
     * 客户id
     */
    @TableField(exist = false)
    private String customerId;

    /**
     * 客户编号
     */
    @TableField(exist = false)
    private String customerNo;

    /**
     * 统一社会信用代码
     */
    @TableField(exist = false)
    private String uscCode;

    /**
     * 客户地址
     */
    @TableField(exist = false)
    private String address;

    /**
     * 委托方联系人名称
     */
    @TableField(exist = false)
    private String clientContactsName;

    /**
     * 创建人
     */
    @TableField(exist = false)
    private String createName;

    /**
     * 创建时间
     */
    @TableField(exist = false)
    private Date createDate;
}
