package com.jeeplus.test.cw.reimbursementApproval.approvalType.domain;

import com.baomidou.mybatisplus.annotation.*;
import com.jeeplus.core.domain.TreeEntity;
import com.jeeplus.core.query.Query;
import lombok.Data;

import java.util.Date;

/**
 * 报销类型信息列表
 * @author: 王强
 * @create: 2022-11-25 08:59
 **/
@Data
@TableName(value = "cw_reimbursement_type_info")
public class CwReimbursementTypeInfo extends TreeEntity<CwReimbursementTypeInfo> {

    private static final long serialVersionUID = 1L;

    /**
     * 实体主键
     */
    @TableId
    private String id;

    /**
     * 创建日期
     */
    @TableField(fill = FieldFill.INSERT)
    private Date createDate;

    /**
     * 创建人
     */
    @Query
    @TableField(fill = FieldFill.INSERT)
    private String createBy;

    /**
     * 更新日期
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private Date updateDate;

    /**
     * 更新人
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    /**
     * 逻辑删除标记
     */
    @TableLogic
    @TableField(fill = FieldFill.INSERT)
    private Integer delFlag;

    /**
     * 层级
     */
    private String level;

    /**
     * 报销类型名称
     */
    @Query
    private String name;

    /**
     * 序号
     */
    @Query
    private Integer sort;

    /**
     * 父节点id
     */
    private String parentId;

    private String parentIds;

    @TableField(exist = false)
    private Boolean disabled = false;

    /**
     * 业务类型
     */
    private String businessType;
}
